<template>
    <form action="" @submit.prevent="submitHandler" method="post">
        <v-card class="mx-auto pa-12 pb-8 mt-3 mb-3" elevation="8" max-width="448" rounded="lg" :loading="isLoading">
            <div class="text-subtitle-1 text-medium-emphasis">Имя пользователя</div>

            <v-text-field density="compact" placeholder="Введите имя пользователя" prepend-inner-icon="mdi-email-outline"
                variant="outlined" required v-model="username"></v-text-field>

            <div class="text-subtitle-1 text-medium-emphasis d-flex align-center justify-space-between">
                Пароль
            </div>

            <v-text-field :append-inner-icon="visible ? 'mdi-eye-off' : 'mdi-eye'" :type="visible ? 'text' : 'password'"
                density="compact" placeholder="Введите пароль" prepend-inner-icon="mdi-lock-outline"
                variant="outlined" @click:append-inner="visible = !visible" required v-model="password"></v-text-field>

            <v-alert v-if="error" :text="error" type="error" class="mb-8"></v-alert>

            <v-btn class="mb-8" color="blue" size="large" variant="elevated" block type="submit" :disabled="isSubmitHandlerBlocked">
                Войти
            </v-btn>

            <v-card-text class="text-center">
                <a class="text-blue text-decoration-none" href="#" rel="noopener noreferrer" target="_blank">
                    Sign up now <v-icon icon="mdi-chevron-right"></v-icon>
                </a>
            </v-card-text>
        </v-card>
    </form>
</template>

<script>
import { useUserStore } from '@/store/user';
import {mapActions, mapState} from 'pinia';

export default {
    data: () => ({
        visible: false,
        username: null,
        password: null
    }),
    methods: {
        ...mapActions(useUserStore, ['login']),
        async submitHandler() {
            const isLoggedIn = await this.login(this.username, this.password);
            if (isLoggedIn) {
                setTimeout(() => this.$router.push('/profile'));
            }
        }
    },
    computed: {
        ...mapState(useUserStore, ['isLoading', 'error']),
        isSubmitHandlerBlocked() {
            return !this.username || !this.password;
        }
    }
}
</script>